package com.kernelmaft.zanbur



object AppState {
	val groups : List <Group> get () = groupsAsMutable
	private var groupsAsMutable : List <Group> = emptyList ()

	private val subscribers : MutableList < ( List <Group> ) -> Unit > = mutableListOf ()

	fun subscribe ( subscriber : ( List <Group> ) -> Unit ) = subscribers . add (subscriber)

	fun addGroup ( group : Group ) {
		groupsAsMutable += group
		subscribers . forEach { it (groups) }
	}

	fun setCurrentScene ( groupId : Int , scene : Scene ) {
		groupsAsMutable = groupsAsMutable . mapIndexed { index , group ->
			if ( index == groupId ) group . copy ( currentScene = scene )
			else group
		}
		subscribers . forEach { it (groups) }
	}
}
